/*
projet :2CTN47K.prj
c:\tc\obj\SANSF.obj
c:\tc\obj\EGAVGAF.obj
c:\tc\obj\CGAF.obj
c:\tc\obj\TRIPF.obj
2CTN47K.c

 fichier lis:
 --------------------------------------------------------------------
 2ctn47K.diz      ce fichier
 2ctn47K.c        le source (non fourni) du programme
 calibctn.bas     le source (non fourni) du programme de calibration CTN
 2ctn47K.pcx      le schema de l'interface
 calibctn.exe     le programme de calibration des CTN
 ctncal.xls       EXCEL 5.0  Calibration graphique,nomenclature interface
 Ctn.cfg          le fichier de configuration CTN necessaire  2CTN47K.exe
 temper.prn       le fichier de sortie des mesures effectuees par 2CTN47K
 1CTN47K.cal      le resultat d'une calibration CTN par calibctn.exe
 2CTN47K.cal
 ...............................................
volutions projet de base:
V0      06/89 montage hard connect sur paddle joystick PC XT
V1.0    01/92 New Hardware avec commutation de Resistances etalons 20K et 100K
V1.1    02/92 Rajout partie grafique  ok en CGA,EGA,VGA
V1.2    03/92 rajout mesure filtree et stockage + ZOOM
V1.3    04/92 rajout mode DEMO
V2.0    11/92 2 eme voie mesure (maxi extensible  5 CTN)
        11/92 fichier de configuration CTN.cfg
V2.1    11/02/93 petites corrections-> distribution version DPTOOL 0293
        14/03/93 correction TEST presence interface pour mode DEMO
        18/04/93 distribution PEARL
V2.2    28/08/94 modification table mesure en flottant au lieu d'entier
        car dbordement comptage avec 486DXII 66MHZ
        rorganisation des commandes ETALON 20K,ETALON 100K,puis CTN...
        rajout TestRatio()
V2.3    22/09/96 modif mineures..
V2.31   30/09/96 rajout adjustdelai automatique pour tempo delai

(c)PF 1996
*/

#ifdef __COMPACT__



#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <Dos.h>
#include <Bios.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include "c:\tc\temper\enregist.tpr"

/*#define  DEBUG*/


#define CR printf("\n");

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;

struct REGPACK Rg;
union REGS Re,Rs;

word i,j,k,l,m,n;      /* variables a tout faire */
word Adresse;
word MicroDelai=4;    /* pour 486DXII 66 */
word far *RbT; /* Ram Bios Timer */
int Lpt;
char c;

float RR;              /* variables specifiques calcul serie */
static double degree;
static double coef[24];
static double Result;
static double xx,yy,zz;

int DEMO;
int NBCTN=2;
int NumZoom=1;

char mes[256];
char Etalon[][11]={"......"," 20K ohms","100 Kohms",
		"CTN1 47K ","CTN2 47K","CTN3 47K ",
                "CTN4 47K","CTN5 47K "};
static char Version[]={"(C)PF 280894 rev 2.5 211196"};
static char Interface[]={"Interface 2 CTN 47K + CD4066 + SN74123"};
long Mesure[8];
word Nombre;
float Periode;
float MiniInterval;
float RatioStd;
float RatioMesur[6],ExRatioMesur[6];
float Moyenne[6],cumul[6];
float MesureFiltree[6];
float Filtre;
float Derivee;
float MaxiTemp[6];
float MiniTemp[6];
float SommeTemp[6];
float TwoSigma[6];

bool drap;
float Ecart;
clock_t Fin,Beg;

int BordH,BordB,BordG,PasX;
float Echelle,MinD,MaxD,PasD,MaxZD,MinZD;
float MaE;
char *pCarte;
bool ZoomFlag,RFlag;

int MaxX,MaxY;
int CarteGraphique;
int ModeGraphique;
int ErrorCode;
int x,Couleur;
int y1[6],y2[6];
int Indice;

long Taille;
FILE *f1;
char NomFich[14];
char *Buff;
char *Tampon;

int Annee;

void InitGraf();
void Delai_uS(long n);
void Couine();
void Ligne(int x1,int y1,int x2,int y2);
void Grille_2(void);
void Grille_Zoom(void);
void Measure();
void TestRatio();
void Entree(char NomFich[14]);
void Pause(char c);
void Rideau();


void AdjustMicroDelai()
{
  long i,xD,xF,xE;
  xD=*(RbT)+*(RbT+2)*65535;
  i=0L;
  while(i<10000000L)i++;
  xF=*(RbT)+*(RbT+2)*65535;
  xE=xF-xD;                     /* duree en 1/18 eme de secondes */
  Ecart=(1000000.0*xE)/18.2;    /* duree en microsecondes */
  MicroDelai=(unsigned int)(Ecart/1000.0);
  printf("\nXd=%10ld \nXF=%10ld \nXE=%10ld\
    \nEcart=%12.3f S pour 10 000 000 de boucles\
    \nMicroDelai pour 10000 boucles =%8d\
    \nDuree de une boucle=%6.6f S",\
    xD,xF,xE,Ecart,MicroDelai,Ecart/10000000);
  if (MicroDelai>10000) MicroDelai=1; else MicroDelai=10000/MicroDelai;
  printf("\nMicroDelai de base =%8d pour 1 S\n",MicroDelai);
}

void Delai_uS(long jjj)           /* delai exprim en S */
{
 long i;
 if (jjj>20)
 {
 i=jjj*MicroDelai;
 while (i>0)i--;
 }
}

void Burp()
{ sound(300);
  Delai_uS(100);
  nosound();
}


void InitGraf()
{
 CarteGraphique=VGA; /* DETECT;*/
 ModeGraphique=VGAHI;
 if(registerfarbgifont(triplex_font_far) < 0)
  {
   Couine();
   printf("\nPb font TRIP non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgifont(sansserif_font_far)<0)
   {
   Couine();
   printf("\nPb font SANS non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgidriver(EGAVGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver EGAVGA non integree ..");
   sleep(2);
   exit(1);
   }
 initgraph (&CarteGraphique,&ModeGraphique,"");
 ErrorCode=graphresult();
 if (ErrorCode!=grOk)
  {
  printf("erreur initialisation Grafique :%s \n",grapherrormsg(ErrorCode));
  sleep(2);
  exit(1);
  }
 MaxX=getmaxx();
 MaxY=getmaxy();
 gotoxy(3,3);
 printf("Initgraf.c");
 gotoxy(3,4);
 pCarte=getmodename(getgraphmode());
 printf("\nCarte detecte = %s",pCarte);
 printf("\nMax X= %5d      Max Y= %5d   ",MaxX,MaxY);
sleep(2);
clearviewport();
}

void Couine()
{
int i;
for (i=100;i<5000;i=i+10)
{
sound(i);
Delai_uS(15);
nosound();
}
nosound();
}

void Ligne(int x1,int y1,int x2,int y2)
{
int deltax,deltay,incrx,incry,e,i;
deltax=abs(x1-x2);
deltay=abs(y1-y2);
incrx=1;if(x2<x1) incrx=-1;
incry=1;if(y2<y1) incry=-1;
  if (deltax>deltay)
  {
  e=2*deltay-deltax;
  for (i=1;i<=deltax;i++)
    { putpixel(x1,y1,Couleur);
     if (e>=0)
      { y1=y1+incry;e=e+(2*deltay-2*deltax);}
      else
      {e=e+2*deltay;}
     x1=x1+incrx;}
    }
   else
   {
   e=2*deltax-deltay;
   for (i=1;i<=deltay;i++)
   { putpixel(x1,y1,Couleur);
    if (e>=0)
    {x1=x1+incrx;
    e=e+(2*deltax-2*deltay);
    }
    else
     {
     e=e+2*deltax;
     }
   y1=y1+incry;
    }
   }
  putpixel(x2,y2,Couleur);
}

void Rideau()
{
 outportb(Lpt,0);
 setcolor(0);
 for (i=0;i<=320;i++)
  {
   sound(480-i);
   line(i,0,i,480);
   line(640-i,0,640-i,480);
  }
  Delai_uS(10);
  nosound();
  closegraph();
#include "c:\tc\temper\USER_tp.txt"
}


void Grille_2(void)
{
int i,j;
float w1;
if (CarteGraphique>1) PasD=1.0; else PasD=2.0;
clearviewport();
BordG=36;
BordH=50;BordB=26;
MinD=0.00;MaxD=40.0;
Echelle=MaxD-MinD;
PasX=50;
gotoxy(1,1);
printf("2CTN47K EGA,VGA Rx=CTN=47K C=4.7F Voie Zoome=%1d Filtre=%3.2f %s",NumZoom,Filtre,Version);
gotoxy(60,3);printf("ESC pour sortir");
Couleur=8;
setcolor(13);
MaE=(MaxY-BordH-BordB)/Echelle;
for (w1=0;w1<=Echelle;w1=w1+PasD)
 {
  if (CarteGraphique==1) Couleur=1; else Couleur=8;
  j=BordH+(w1*MaE);
  Ligne(BordG,j,MaxX-2,j);
  sprintf(mes,"%2.1f",MaxD-w1);
  outtextxy(1,j-4,mes);
 }
j=0;
for (i=BordG;i<MaxX-2;i=i+PasX)
{
  Ligne(i,BordH,i,MaxY-BordB);
  sprintf(mes,"%03d",j);
  outtextxy(i-20,MaxY-10,mes);
  j=j+PasX;
}
Couleur=15;
Ligne(BordG,MaxY-BordB,MaxX-2,MaxY-BordB);
Ligne(BordG,BordH,BordG,MaxY-BordB);
Couleur=15;
Measure(NBCTN);
Nombre=1;
for (n=1;n<=NBCTN;n++)
{
RatioMesur[n]=((float)(Mesure[2+n]-Mesure[1])/(float)Mesure[1])/RatioStd;
RR=log(RatioMesur[n]);
Result=poly(RR,4,&coef[4*(n-1)]);
if(Result<MinD) Result=MinD;
if(Result>MaxD) Result=MaxD;
RFlag=TRUE;
y1[n]=MaxY-BordB-(Result-MinD)*MaE;
setcolor(10+n);
moveto(BordG+Nombre,y1[n]);
y2[n]=y1[n];
cumul[n]=0.0;
}
c=0;
}


void Grille_Zoom(void)
{
int i,j;
float w1,w2;
clearviewport();
BordG=46;
BordH=50;BordB=26;
if (CarteGraphique>1) PasD=0.10; else PasD=0.20;
w2=ceil(Moyenne[NumZoom]*10.0)/10.0;
MinZD=w2-2.00;
MaxZD=w2+2.00;
Echelle=4.00;
PasX=50;
gotoxy(1,1);
printf("2CTN47K EGA,VGA Rx=CTN=47K C=4.7F Voie Zoome=%1d Filtre=%3.2f %s",NumZoom,Filtre,Version);
gotoxy(50,3);printf("<N>ormal");
gotoxy(60,3);printf("ESC pour sortir");
Couleur=8;
setcolor(13);
MaE=(MaxY-BordH-BordB)/Echelle;
for (w1=0;w1<=Echelle;w1=w1+PasD)
 {
  if (CarteGraphique==1) Couleur=1; else Couleur=8;
  j=BordH+(w1*MaE);
  Ligne(BordG,j,MaxX-2,j);
  sprintf(mes,"%1.2f",MaxZD-w1-w2);
  outtextxy(1,j-4,mes);
 }
j=0;
for (i=BordG;i<MaxX-2;i=i+PasX)
{
  Ligne(i,BordH,i,MaxY-BordB);
  sprintf(mes,"%03d",j);
  outtextxy(i-20,MaxY-10,mes);
  j=j+PasX;
}
Couleur=15;
Ligne(BordG,MaxY-BordB,MaxX-2,MaxY-BordB);
Ligne(BordG,BordH,BordG,MaxY-BordB);
setcolor(10+NumZoom);
sprintf(mes,"Centrage sur %2.3f",w2);
gotoxy(1,3);printf("                                ");
outtextxy(40,32,mes);
for (j=1;j<=NBCTN;j++)
 {
 cumul[j]=0.0;
 }
Nombre=0;
j=MaxY-BordB-(w2-MinZD)*MaE;
moveto(BordG+Nombre,j);
c=0;
}


void Measure(int n)
{
 int i;
 long k,l;
 outportb(Lpt,0);
 if (DEMO==TRUE)
  {
  Mesure[2]=19670;
  Mesure[1]=4080;
  for (i=1;i<=2+n;i++) Mesure[2+i]=11250+random(100);
  if (kbhit()) {c=getch();c=(c>96)?c-32:c;}
  Delai_uS(100);
  }
  else
  {
  for (i=0;i<=1+n;i++)
  {
  /* disable();*/
  k=1<<i ;
  outportb(Lpt,k);
  outportb(Lpt,k | 128);
  k=0;
  l=0;
  do
  {
   j=inportb(Lpt+1)&64;
   if (j==0) k++;
   l++;
  }
  while ((j==0) &&(l<320000L));
  /*enable();*/
  Mesure[i+1]=k;
  if (kbhit()) {c=getch();c=(c>96)?c-32:c;}
  }
 }
}

void Entree(char NomFich[14])
{
byte b;
char c;
char tempo[14];
byte i,l,x,y;
i=0;
strcpy(tempo,"");
strcpy(NomFich,"");
printf("\nNom du fichier de stockage <8 car > : ");
x=wherex();y=wherey();
gotoxy(x,y);
do
 {
 c=getch();
 if(c!=27 && c!=13 && c!=0x07)
 {
  printf("%c",c);
  strncat(tempo,&c,1);
  i++;
  }
 if (c==0x07 || c==0x08)
 {
  if(i>0)
   {
   i--;
   gotoxy(x-1+i,y);
   clreol();
   tempo[i]='\00';
   if (i>0) {i--;};
   tempo[i]='\00';
   }
  }
 }
while (c!=27 && c!=13 && i<8 );
tempo[8]='\00';
if (strlen(tempo)==0) strcpy(tempo,"Noname");
if (strlen(tempo)<=8) strcat(tempo,".tem");
strcpy(NomFich,tempo);
NomFich[13]='\00';
}

void Pause(char ccc)
{
char c1;
 if (ccc>32)
  {
  printf("Appuyer sur <%c> ",ccc);
  }
  else

  {
   switch (ccc)
   {
   case 27:
   printf("Appuyer sur <ESC> ");
   break;
   case 13:
   printf("Appuyer sur <RETURN>");
   break;
   default:
   printf("Appuyer sur une Touche");
   break;
   }
 }
 c1=0;
 while((c1!=ccc)&&(c1!=27))
 {
 if (kbhit()) c1=getch();
 if (c1>96) c1=c1-32;
 }
}

void HMS()
{
  byte i;
  Re.h.ah =0x2C;	/* lecture de l'heure */
  Re.x.dx = 0;
  int86(0x21,&Re,&Rs);
  strcpy(Buff,"          ");
  i=Rs.h.ch;
  *(Buff)=i/10+0x30;
  *(Buff+1)=i%10+0x30;
  i=Rs.h.cl;
  *(Buff+2)=':';
  *(Buff+3)=i/10+0x30;
  *(Buff+4)=i%10+0x30;
  i=Rs.h.dh;
  *(Buff+5)=':';
  *(Buff+6)=i/10+0x30;
  *(Buff+7)=i%10+0x30;
  *(Buff+8)='\0';
 }

int JMA()
{
  byte i;
  Re.h.ah =0x2A;	/* lecture de l'heure */
  Re.x.dx = 0;
  int86(0x21,&Re,&Rs);
  strcpy(Buff,"               ");
  i=Rs.h.dl;
  *(Buff)=' ';
  *(Buff+1)=i/10+0x30;
  *(Buff+2)=i%10+0x30;
  i=Rs.h.dh;
  *(Buff+3)='/';
  *(Buff+4)=i/10+0x30;
  *(Buff+5)=i%10+0x30;
  *(Buff+6)='/';
  Annee=Rs.x.cx;
  itoa(Annee,Buff+7,10);
  return(Annee);
 }

void TestRatio()
{
if (Mesure[1]!=320000L && Mesure[2]!=0 && Mesure[1]!=0)	RatioStd=((float)Mesure[2]-(float)Mesure[1])/(float)Mesure[1];
if ((Mesure[1]>0) & (RatioStd<3.5 || RatioStd>4.1))
 {
  clrscr();
  CR
  textcolor(132);
  cprintf(" PROBLEME : Ratio Hors limite...");
  CR
  printf("\nProbleme d'interface....ou connectique...ou R ETALON ..?? ");
  printf("\nRatio Std mesur = %5.4f au lieu de Normal= 3.5  4.1 ",RatioStd);
  for (i=1;i<=2+NBCTN;i++) printf("\nmesure %3d = %8ld",i,Mesure[i]);
  Couine();
  sleep(3);
  printf("\n\n");
  Pause(27);
  exit(96);
 }
}



void main (int argc,char *argv[])
{
clrscr();
RbT= MK_FP (0x0040,0x006c);
Beg=*(RbT)+*(RbT+2)*65535;
AdjustMicroDelai();
printf("\nVoulez vous voir le schema : <O,N> ? ");
c=(char) getch();
c=(c>96)?c-32:c;
if(c=='O')
{
system ("CGA640.com");
system ("loadscrn 2CTN47K.CGA");
do
{}
while (!kbhit());
system ("texte.com");
}
/* ------------------------------------------------- */
clrscr();
Buff=(char *)malloc(200);
Tampon=(char *)malloc(200);
if(argc>1)
 {
  strcpy(Tampon,argv[1]);
  strupr(Tampon);
  if (strstr(Tampon,"CTN.CFG")==NULL)
   {
   printf("\n %s",strstr(Tampon,"CTN.CFG"));
   printf("\nerreur fichier de config: %s",Tampon);
   sleep(2);
   Couine();
   exit(92);
   }
  printf("\nFichier de Configuration CTN passs en parametre=");
  cprintf(" %s.",Tampon);
  f1=fopen(Tampon,"r+b");
  i=fseek(f1,0,SEEK_END);
  Taille=ftell(f1);
  i=fseek(f1,0,SEEK_SET);
  printf("\ntaille fichier= %6ld octets\n",Taille);
  sleep(1);
  i=fread(Buff,Taille,1,f1);
  l=1;
  Tampon=strtok(Buff,"___________");
  *(Tampon+10)='\0';
  if (strncmp(Tampon,"PORT LPT=",9)==0)
  {
   k=atoi(Tampon+9);
   switch (k)
   {
   case 1:
    Lpt=0x378;break;
   case 2:
    Lpt=0x278;break;
   default:
    Lpt=0x378;
   }
  }
  else
  {
  Couine();
  printf("\nerreur Fichier de config ligne %3d\n",l);
  }
  l=2;
  Tampon=strtok(NULL,"___________");
  *(Tampon+10)='\0';
  if (strncmp(Tampon,"FILTRE=",7)==0)
  {
  Filtre=(float)atof(Tampon+7);
  }
  else
  {
  Couine();
  printf("\nerreur Fichier de config ligne %3d",l);
 }

 l=3;
 Tampon=strtok(NULL,"___________");
 *(Tampon+8)='\0';
 if (strncmp(Tampon,"NBCTN=",6)==0)
  {
   NBCTN=atoi(Tampon+6);
  }
  else
  {
  Couine();
  printf("\nerreur Fichier de config ligne %3d\n",l);
  }
  if (NBCTN>5) NBCTN=5;
  if (NBCTN<1) NBCTN=1;
  strcpy(NomFich,"COEF[00]=");
  for (j=0;j<NBCTN*4;j++)
  {
   if (j<10)
     *(NomFich+6)=48+j;
     else
     {
     *(NomFich+5)=49;
     *(NomFich+6)=(j-10)+48;
   }
  l++;
  Tampon=strtok(NULL,"_______________");
  *(Tampon+17)='\0';
  if (strncmp(Tampon,NomFich,8)==0)
  {
   coef[j]=atof(Tampon+9);
  }
  else
  {
  Couine();
  printf("\nerreur Fichier de config ligne %3d\n",l);
  }
  }
  fclose(f1);
  }
  else
  {
  printf("\nManque arguments...=> Lpt2 par dfaut 2 CTN Filtre=0.5..");
  printf("\nEx de commande :   2CTN47K CTN.cfg");
  printf("\n CTN.cfg=contient le N de PORT LPT,le Nb de CTN,valeur de filtre");
  printf("\n et les parametres de calibration de chaque sonde CTN");
  Lpt=0x278;
  k=2;
  Filtre=0.5;
  NBCTN=2;
  coef[0]=10.8567;
  coef[1]=-20.2789;
  coef[2]=-13.97465;
  coef[3]=-9.11449;
  coef[4]=10.8567;
  coef[5]=-20.2789;
  coef[6]=-13.97465;
  coef[7]=-9.11449;
  sleep(1);
 }
 printf("\nNombre de CTN = %3d",NBCTN);
 printf("\nFiltre=%3.2f",Filtre);
 printf("\nPort LPT=%04x",Lpt);
 for (n=0;n<NBCTN;n++)
 {
 gotoxy(1,9+5*n);
 printf("Coefficients de calibration CTN %2d :",n+1);
 printf("\nA0=%5.3f",coef[0+4*n]);
 printf("\nA1=%5.3f",coef[1+4*n]);
 printf("\nA2=%5.3f",coef[2+4*n]);
 printf("\nA3=%5.3f",coef[3+4*n]);
 MaxiTemp[n+1]=-999.0;
 MiniTemp[n+1]=999.0;
 SommeTemp[n+1]=0.0;
 TwoSigma[n+1]=0.0;
 }
printf("\n\n");
Pause('N');
textcolor(2);

sleep(1);
DEMO=FALSE;
MaxD=40.0;MinD=0.0;
clrscr();
textcolor(10);
cprintf("Mesures de Temprature 0  40c avec autocalibration. %s",Version);
gotoxy(1,2);
cprintf("Moyennes glissantes calcules toutes les 50 mesures..");
gotoxy(1,3);
cprintf("ZOOM -2.0C  + 2.0C POSSIBLE des que la moyenne de 50 mesures est effectue");
gotoxy(1,4);
cprintf("Choix de la sonde (moyenne de rfrence) par touche + et -");
textcolor(12);
gotoxy(1,5);
cprintf("Possibilit de pilotage jusqu'a 5 sondes CTN !!!");
textcolor(2);
gotoxy(1,7);
printf("\nCommutation des voies par circuit 4066 sur 20K,100K,CTN1..CTN5 ");
printf("\nCircuit 74HCT123 avec CTNs de valeur nominale= 47Kohms et C=4,7F");
printf("\nAiguillage via sortie LPT%1d  < D0=20K,D1=100k,D2=CTN1,D3=CTN2...D6=CTN5 >",k);
printf("\nDclenchement par D7=9 ");
printf("\nLecture dure sur ACK=10 de Lpt=%04X",Lpt);
printf("\n\n");
Nombre=0;
Pause('S');
clrscr();
c=0;
Measure(1);
TestRatio();
gotoxy(1,13);
textcolor(3);
cprintf(".");
if (Mesure[1]!=320000L && Mesure[2]!=0 && Mesure[1]!=0)
  RatioStd=((float)Mesure[2]-(float)Mesure[1])/(float)Mesure[1];
  else
  {
  Couine();
  CR
  textcolor(132);
  cprintf(" PROBLEME : pas de signal sur ACK");
  printf("\n");
  cprintf(" Causes: Mauvais port LPT,pas d'INTERFACE , pas de sonde CTN...");
  sleep(1);
  printf("\n");textcolor(2);cprintf(" donc mode DEMOnstration...!!");
  RatioStd=3.80;
  DEMO=TRUE;
  Measure(NBCTN);
  RatioStd=((float)Mesure[2]-(float)Mesure[1])/(float)Mesure[1];
  sleep(2);
  clrscr();
  textcolor(3);cprintf("MODE DEMO ");
/*  gotoxy(10,25);printf("Appuyer sur ESC pour Grafique ");*/
 }
 clrscr();
 textcolor(15);
 cprintf("Cet ecran peut servir  relever les Ratios f(Temprature reelle)");
 printf("\n");
 cprintf("pour faire ensuite une CALIBRATION avec CALIBCTN.exe");
 textcolor(6);
 gotoxy(1,4);printf("Ratio Std issu des resistances ETALONS < Normal=3.80 > = ");
 cprintf("%5.3f",RatioStd);
 TestRatio();
 gotoxy(1,20);
 printf("Appuyer sur <G> pour Graphique ...ou....ESC pour sortir ");
 c=' ';
 do
 {
  Measure(NBCTN);
  TestRatio();
  textcolor(6);
  gotoxy(1,4);
  printf("Ratio Std issu des resistances ETALONS < Normal=3.80 > =          ");
  cprintf("%5.3f",RatioStd);
  gotoxy(1,17);
  textcolor(2);
  cprintf("ETALON 20K   =");
  textcolor(12);
  cprintf(" %8ld counts ",Mesure[1]);
  textcolor(6);
  gotoxy(1,18);
  textcolor(2);
  cprintf("ETALON 100K  =");
  textcolor(12);
  cprintf(" %8ld counts ",Mesure[2]);
  textcolor(6);
  for (n=1;n<=NBCTN;n++)
  {
   RatioMesur[n]=((float)(Mesure[2+n]-Mesure[1])/(float)Mesure[1])/RatioStd;
   textcolor(12);
   gotoxy(1,3+n*2);printf("Mes.CTN%1d filtre avec k=%3.2f => ",n,Filtre);
   if (Nombre==0) ExRatioMesur[n]=RatioMesur[n];
      else
      RatioMesur[n]=(1.00-Filtre)*ExRatioMesur[n]+Filtre*RatioMesur[n];
   gotoxy(30,3+n*2);
   cprintf("%8ld counts ",Mesure[2+n]);
   textcolor(12);
   gotoxy(60,3+n*2);
   cprintf("Ratio= %5.5f",RatioMesur[n]);
   RR=log(RatioMesur[n]);
   Result=poly(RR,4,&coef[4*(n-1)]);
   gotoxy(1,4+n*2);printf("Mes.CTN%1d en degrs celcius  = ",n);
   gotoxy(30,4+n*2);
   textcolor(14);
   cprintf("%5.3f C ",Result);
   printf(" ou  ");
   gotoxy(50,4+n*2);
   textcolor(14);
   Result=(Result*9/5)+32.0;
   cprintf("%5.3f F ",Result);
   Nombre++;
   ExRatioMesur[n]=RatioMesur[n];
   }
}
while ((c!='G') && (c!=27));
if (c==27)
  {
   textcolor(132);CR;CR
   cprintf("Sortie volontaire de programme...");
   CR;
   sleep(2);
   exit(92);
}
c=0;
clrscr();
#ifndef NOTREGISTERED
 Entree(NomFich);
 f1=fopen(NomFich,"w+b");
 gotoxy(1,3);
 printf("Fichier %s ouvert ",NomFich);
 MiniInterval=1.5+0.5*NBCTN;
 do
 {
 Periode=0;
 gotoxy(1,4);
 printf("Intervalle de stockage des mesures < %3.1fs  600.0s>",MiniInterval);
 scanf("%f",&Periode);
 }
while ((Periode<(1.5+0.5*NBCTN))||(Periode>600.0));
printf("\nPriode =1,5+ 0,5s *Nb de CTN soit %3.1f sec",Periode);
sleep(2);
#else
printf("\nVersion SHAREWARE non enregistre => Fichier et priode impose");
strcpy(NomFich,"essai.tem");
f1=fopen(NomFich,"w+b");
Periode=10+NBCTN*0.5;
printf("\nFichier Essai.tem ouvert....");
printf("\nPriode =10 secondes + (0,5 sec * Nb de CTN) soit %3.1f sec",Periode);
sleep(4);
#endif
InitGraf();
PasD=1;
NumZoom=1;
Grille_2();
c=0;
RFlag=TRUE;
ZoomFlag=FALSE;
Indice=1;
Nombre=1;
JMA();
i= fprintf(f1,"%s%c",Buff,9);
HMS();
i= fprintf(f1,"%s%cPeriode=%5.2fSec%c%c",Buff,9,Periode,10,13);

/* -------- Boucle principale ----------- */

do
{
Beg=*(RbT)+*(RbT+2)*65535;
do
{
Measure(NBCTN);
 gotoxy(60,2);
 printf("x=%4d Indic=%5d",Nombre,Indice);
 for (n=1;n<=NBCTN;n++)
 {
  RatioMesur[n]=((float)(Mesure[2+n]-Mesure[1])/(float)Mesure[1])/RatioStd;
  if (Nombre==1) ExRatioMesur[n]=RatioMesur[n]; else RatioMesur[n]=0.8*ExRatioMesur[n]+0.2*RatioMesur[n];
  RR=log(RatioMesur[n]);
  Result=poly(RR,4,&coef[(n-1)*4]);
  gotoxy(1,2);printf("Mesures = ");
  setcolor(14);
  if(Result<MinD) Result=MinD;
  if(Result>MaxD) Result=MaxD;
  if (Nombre==1) MesureFiltree[n]=Result;
  MesureFiltree[n]=0.9*MesureFiltree[n]+0.1*Result;
  cumul[n]=cumul[n]+Result;
  if (RFlag==TRUE)
     y1[n]=MaxY-BordB-(Result-MinD)*MaE;
      else
      y1[n]=MaxY-BordB-(Result-MinZD)*MaE;
  if (Nombre==1) y2[n]=y1[n];
  setcolor(10+n);
  moveto(BordG+Nombre,y2[n]);
  putpixel(BordG+Nombre,y2[n],10+n);
  Result=(Result*9/5)+32.0;
  gotoxy(11+(n-1)*9,2);
  printf("%5.3f",MesureFiltree[n]);
  ExRatioMesur[n]=RatioMesur[n];
  lineto(BordG+Nombre,y1[n]);
  y2[n]=y1[n];
  if((Nombre>49) && (Nombre %50==0)&& (RFlag==TRUE))
  {
  setfillstyle(SOLID_FILL,0);
  bar(1+(n-1)*100,34,1+n*100,44);
  setcolor (4);
  Moyenne[n]=cumul[n]/50.0;cumul[n]=0;
  setcolor(10+n);
  sprintf(mes,"Moy%1d=%2.3f",n,Moyenne[n]);
  outtextxy(1+(n-1)*100,34,mes);
  moveto(BordG+Nombre,y1[n]);
  }
  if ((Nombre>49)&&(RFlag==TRUE)&&(Moyenne[n]>5.0)&&(Moyenne[n]<30.0))
 {
  gotoxy(50,3);printf("<Z>oom");
  ZoomFlag=TRUE;
 }

 }  /* fin boucle FOR n */
 if ((c=='Z') && (ZoomFlag==TRUE))
  {
   c=0;
   RFlag=FALSE;
   ZoomFlag=TRUE;
   Grille_Zoom();
  }
 if (c=='N')                      /* grille Normale */
 {
   c=0;
   RFlag=TRUE;
   ZoomFlag=FALSE;
   Grille_2();
 }
 if (((c=='+') || (c=='-'))&&(RFlag==FALSE)&& (ZoomFlag==TRUE))
 {
   if ((c=='+')&& (NumZoom<NBCTN)) NumZoom++; else Burp();
   if ((c=='-')&& (NumZoom>1)) NumZoom--; else Burp();
   c=0;
   Grille_Zoom();
  }
 Nombre++;
 Fin=*(RbT)+*(RbT+2)*65535;
 Ecart=(float)(Fin-Beg)/CLK_TCK;
 #ifdef DEBUG
 gotoxy(45,3);printf("debut =%8ld  fin=%8ld",Beg,Fin);
 #endif

 if (Nombre>602) Grille_2();
 }
while (Ecart<Periode) ;
HMS();
fprintf(f1,"%s %c",Buff,9);
for (n=1;n<=NBCTN;n++)
{
 MaxiTemp[n]=MesureFiltree[n]>MaxiTemp[n]?MesureFiltree[n]:MaxiTemp[n];
 MiniTemp[n]=MesureFiltree[n]<MiniTemp[n]?MesureFiltree[n]:MiniTemp[n];
 SommeTemp[n]=SommeTemp[n]+MesureFiltree[n];
 if(fprintf(f1,"%4.3f \t",MesureFiltree[n])==0) exit(96);
 }
i= fprintf(f1,"%c%c",13,10);
Indice++;
}
while (c!=27);
Indice--;
fprintf(f1,"CTN %c Maxi%c Moyenne%c  Mini %c%c",9,9,9,13,10);
for (n=1;n<=NBCTN;n++)
{
 fprintf(f1,"%1d %c %4.3f %c %4.3f %c %4.3f %c%c",n,9,MaxiTemp[n],9,SommeTemp[n]/Indice,9,MiniTemp[n],13,10);
}
JMA();
i= fprintf(f1,"Fin de mesure %s%c",Buff,9);
HMS();
i= fprintf(f1,"%s%c%c",Buff,10,13);
fclose(f1);
setcolor(0);
Rideau();
sleep(1);
}
#endif
#ifndef __COMPACT__
#error Please,le mode COMPACT !!!!
#endif
