/*
-------------------
GRAPHICS.lib
D:\tc\obj\TRIPF.obj
D:\tc\obj\SANSF.obj
D:\tc\obj\EGAVGAF.obj
D:\tc\obj\CGAF.obj
D:\tc\temper\Pt1000.c
fichiers lis:
-------------
D:\tc\temper\Pt1000.diz
D:\tc\temper\user_tp.txt
EGAHi.com       passe le mode vido en mode EGAHI
loadscrn.com    charge image format EGA
pt1000.EG1      schema au format EGA
texte.com       passe video en mode texte
_____________________

(c)PF

Sujet : Mesures de tempratures

Ŀ
 Nom    : PT1000.c          DOS 6.22    Video : Cirrus VGA,VESA       
 Date   : 01 Fevrier 97     Materiel:   PC EET 486DXII 66Mhz 	       
 Auteur : Paul FREYER       Langage :   Turbo C v2.00 Borland         
 But    : Mesure de temperature par sonde CTP Pt1000 avec             
          calibration sur 0C et 65C , mesure ratiometrique au lieu  
          de mesure absolue.Graphique mesure brute et mesure filtre. 
          ZOOM possible sur +/- 0.5C par rapport  moyenne ......... 


V0  	issue de 100all.c sonde PT100 ohm DIN
V1.0    modif hardware: etalon 1500 ohms pour echelle maxi 129,8C au
	lieu de 65C

Email : PaulFjujo@aol.com
*/

#ifdef __COMPACT__
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphics.h>
#include <alloc.h>
#include <conio.h>

/*#define NOT_REGISTERED*/
char Version[]={"V1.3(C)P.F.0697 rev 251200"};
char Interface[]={"NePt1000.sdr  NE555+7406+3 relais+1000ohms+1500ohms+Pt1000"};

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;
typedef enum { ESCAPE=0x0011B,ENTER=0x1C0D,ESPACE=0x3920,CTRL_ENTER=0x1C0A };

union REGS Re,Rs;
struct REGPACK Rg;

#define CR printf("\n");
#define  BUSY (inportb(Base+1)& Bit7)
#define ACK (inportb(Base+1)& Bit6)
#define Bit6 0x40
#define Bit7 0x80

unsigned int b,i,j,l,m;
unsigned int HautCar;
long k;
char a,c,d,c1,c2;

/* variables specifiques mesure de temperature et grafe */

float Zero,Echelle;	/* valeur en counts des etalons 0 et 75 */
float Sensib,MaE;       /* coefficient de mise a l'echelle grafique */
float RatioE;		/* rapport de signal entre 0 et 75 etalons .*/
float RatioM; 	  	/* utilisation du rapport de signal 0,00  1,00 au lieu de val absolue*/
float Temp,Temp0;	/* variables pour elaborer le filtrage exponentiel */
float Temp2,OldTemp2;   /* variables graf NOW MESURE en ega ou vga only */
float Temp1;
float Moyenne;		/* moyenne temperature */
float BDeg,EDeg,Deg;    /*Debut,Fin d'echelle,Valeur en cours*/
float BzDeg,EzDeg;      /*Debut,Fin d'echelle pour ZOOM*/
float PasDeg,PasZDeg;   /* Pas de Graduations pour axe Y graphe Normal et ZOOM */
float ZMaE;		/* coef de Mise  l'echelle degC et pixel en mode ZOOM */
float ValEtal;          /* valeur de l'echelle de calibration 1500ohms=> 129.8C */

int Base;		/* adresse port paralle : LPt ou Proto */
int NbEch;		/* Population echantillonage mesure */
int Ps;			/* periode de stockage sur fichier */
int Tec; 		/* mesure du temps ecoul en secondes */

byte Secondes; 		/* variables pour detecter le changement de seconde */
byte OldSec;            /* pour etre compatible XT ne utiliser la RAM CMOS horloge*/
word *RbT; 		/* pointeur sur zone Ram comptage pulses 1/18 em de secondes */
long Pulse,OldPulse;

int DrpZOOM,ZOOM;       /* Zoom only si valeur de rference */
int DEMO;		/* si pas d'interface connect */

FILE *f1;
char Tampon[128];
char Nom[13];

long Taille;
int CarteGraphique,ModeGraphique,ErrorCode;
int MaxX,MaxY;
int Indice,x,Drap;
int Couleur;

char far  *Tableau1; /* stockage temporaire pour glissement courbe  grafe */
char far  *Tableau2;

void Ticks();
void InitGraf();
void Titre(int xx,int yy,int zz,char *msx);
void Grille();
long ACKCount();
void Tarage();
void Calibration();
void Pause(char c1);
void Delais(int jjj);
void Couine();
void Boof();
void Burp();
void Rideau();
void ToRegistered();

void Ticks()
{
 disable();
 Pulse=*(RbT)+*(RbT+2)*65535;
 if (Pulse>OldPulse+18)
 {
 Secondes++;
 OldPulse=Pulse;
 }
 enable();
}

void InitGraf()
{
 CarteGraphique=DETECT;
 if(registerfarbgifont(triplex_font_far) < 0)
  {
   Couine();
   printf("\nPb font TRIP non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgifont(sansserif_font_far)<0)
   {
   Couine();
   printf("\nPb font SANS non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgidriver(EGAVGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver EGAVGA non integree ..");
   sleep(2);
   exit(1);
   }
 initgraph (&CarteGraphique,&ModeGraphique,"");
 ErrorCode=graphresult();
 if (ErrorCode!=grOk)
  {
  printf("erreur initialisation Grafique :%s \n",grapherrormsg(ErrorCode));
  sleep(2);
  exit(1);
  }
 MaxX=getmaxx();
 MaxY=getmaxy();
 gotoxy(3,3);
 printf("Initgraf.c");
 gotoxy(3,4);
 printf("Mode detect = ");
 switch (CarteGraphique)
 {
 case 1:printf(" CGA ");break;
 case 2:printf(" MCGA");break;
 case 3:printf(" EGA ");break;
 case 4:printf(" EGA 64 ");break;
 case 5:printf(" EGA mono");break;
 case 6:printf(" IBM 8514");break;
 case 7:printf(" HERCules");break;
 case 9:printf(" VGA ");break;
 case 10:printf(" PC3270 ");break;
 default:printf(" unknow ? ");break;
 }
 printf(" %3d   Max X= %5d    Max Y= %5d",CarteGraphique,MaxX,MaxY);
 sleep(1);
 clearviewport();
 HautCar=textheight("H")*2 ;
}

void Titre(int xx,int yy,int zz,char *msx)
{
 setfillstyle(SOLID_FILL,0);
 setcolor(Couleur);
 settextstyle(TRIPLEX_FONT,HORIZ_DIR,zz);
 bar(xx,yy,xx+90,yy+textheight(msx));
 outtextxy(xx,yy,msx);
 setcolor(10);
}

void Grille()
{
 int y;
 float i;
 clearviewport();
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(7);
 for (i=BDeg;i<=EDeg;i=i+PasDeg)
  {
   y=MaxY-HautCar-i*MaE;
   line(20,y,600,y);
   setcolor(3);
   sprintf(Tampon,"%2.0f",i);
   outtextxy(1,y-textheight(Tampon)/2,Tampon);
   setcolor(7);
  }
 for (i=480;i>=0;i=i-60)
  {
   x=600-i;
   setcolor(12);
   line(x,MaxY,x,MaxY-HautCar);
   setcolor(3);
   sprintf(Tampon,"%2.0f",(480.0-(float)i)/60.0);
   outtextxy(120+i-textwidth(Tampon),MaxY-textheight(Tampon),Tampon);
   setcolor(7);
  }
 strcpy(Tampon,"Duree ");
 outtextxy(16,MaxY-10,Tampon);
 setcolor(10);
 Couleur=13;
 strcpy(Tampon,"Pt1000.C");
 Titre(25,8+CarteGraphique*2,2+CarteGraphique/3,Tampon);
 gotoxy(1,5);printf("C");
 Couleur=14;
 gotoxy(1,1);
 printf("%s",Version);
 gotoxy(20,1);
 printf("Zero=%8.0f  Echelle=%8.0f Sensib =%6.5f C par Cnt",Zero,Echelle,Sensib);
 gotoxy(50,4);
 printf("D=0C F=130C X=1000         ");
 gotoxy(50,5);
 printf("N=NORMAL  T=Tarage ESC=Sortie");
 settextstyle(SANS_SERIF_FONT,HORIZ_DIR,1);
/* getimage(599,MaxY/5+2,600,MaxY-14-CarteGraphique,Tableau2);*/
 getimage(599,MaxY/5+2,600,MaxY-HautCar,Tableau2);
 if (CarteGraphique>1)    /* carte EGA ou VGA only */
 {
 Couleur=10;
 strcpy(Tampon,"Filtree");
 Titre(300,10+CarteGraphique*2,2,Tampon);
 Couleur=12;
 strcpy(Tampon,"Brute");
 Titre(300,35+CarteGraphique*2,2,Tampon);
 }
 x=20;
 moveto(x,MaxY-HautCar-Temp1*MaE);
 OldTemp2=Temp1;
}

void Grille_ZOOM()
{
 float i,y;
 clearviewport();
 gotoxy(1,1);
 printf("%s",Version);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(7);
 BzDeg=Moyenne-5.0*PasZDeg;
 EzDeg=Moyenne+5.0*PasZDeg;
 ZMaE=(MaxY-HautCar-MaxY/5)/(10.0*PasZDeg);
 for (Deg=BzDeg;Deg<=EzDeg;Deg=Deg+PasZDeg)
  {
   y=MaxY-HautCar-(Deg-BzDeg)*ZMaE;
   line(35,y,600,y);
   setcolor(3);
   sprintf(Tampon,"%2.1f",Deg);
   outtextxy(1,y-textheight(Tampon)/2,Tampon);
   setcolor(7);
  }
 for (i=480;i>=0;i=i-60)
  {
   x=600-i;
   setcolor(12);
   line(x,MaxY,x,MaxY-HautCar);
   setcolor(3);
   sprintf(Tampon,"%2.0f",(480.0-i)/60.0);
   outtextxy(120+i-textwidth(Tampon),MaxY-textheight(Tampon),Tampon);
   setcolor(7);
  }
 strcpy(Tampon,"Duree ");
 outtextxy(16,MaxY-10,Tampon);
 setcolor(10);
 Couleur=13;
 strcpy(Tampon,"100.C");
 Titre(25,10+CarteGraphique*2,2+CarteGraphique/3,Tampon);
 gotoxy(1,5);printf("C");
 Couleur=14;
 gotoxy(20,1);
 printf("Zero=%8.0f  Echelle=%8.0f Sensib =%6.5f C par Cnt",Zero,Echelle,Sensib);
 gotoxy(50,4);
 printf("D=0C F=130C X=1000         ");
 gotoxy(50,5);
 printf("N=NORMAL  T=Tarage ESC=Sortie");
 settextstyle(SANS_SERIF_FONT,HORIZ_DIR,1);
  getimage(599,MaxY/5+2,600,MaxY-HautCar,Tableau2);
 /*getimage(599,MaxY/5+2,600,MaxY-14-CarteGraphique,Tableau2);*/
 if (CarteGraphique>1)    /* carte EGA ou VGA only */
 {
 Couleur=10;
 strcpy(Tampon,"Filtree");
 Titre(300,10+CarteGraphique*2,2,Tampon);
 }
 x=35;
 moveto(x,MaxY-HautCar-(Moyenne-BzDeg)*ZMaE);
 Temp1=Temp;
}

long ACKCount()
{
long k;                   /* acquisition mesure */
disable();
k=0;
while (ACK==0);          /* synchro sur front descendant */
while (ACK==64);        /* synchro sur front montant */
while (ACK==0);          /* synchro sur front descendant */
while (ACK==64);        /* synchro sur front montant */
while (ACK==0) k++;     /* comptage front bas */
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64);
while (ACK==0) k++;
while (ACK==64);
while (ACK==0) k++;
while (ACK==64);
while (ACK==0) k++;     /* comptage front bas */
while (ACK==64);
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0) k++;
while (ACK==64) ;
while (ACK==0)  k++;
while (ACK==64);
while (ACK==0)  k++;
while (ACK==64);
/*
while (ACK==0)  k++;
while (ACK==64) k++;
*/
enable();
return(k);
}

void Tarage()
{
int i;
if (DEMO==FALSE)
 {
 NbEch=10;
 outportb(Base,1);       /* aiguillage relais sur 1000 ohms soit 0C */
 Delais(300);
 i=0;
 Zero=0.0;
 do {Zero=Zero+ACKCount(); i++; } while (i<NbEch);
 outportb(Base,2);      /* aiguillage relais sur 1500 ohms soit 130C */
 Delais(300);
 i=0;
 Echelle=0.0;
 do { Echelle=Echelle+ACKCount();i++;} while(i<NbEch);
 Sensib=ValEtal*NbEch/(Echelle-Zero);
 Echelle=Echelle/NbEch;
 Zero=Zero/NbEch;
 RatioE=Zero/Echelle;
 outportb(Base,4);
 Delais(300);
 }
 else
 {
 randomize();
 Zero=2250000;
 Echelle=4088823;
 Sensib=ValEtal/(Echelle-Zero);
 }
 gotoxy(20,1);
 printf("Zero=%8.0f  Echelle=%8.0f Sensib =%6.5f C par Cnt",Zero,Echelle,Sensib);
 RatioE=Zero/Echelle;
}

void Calibration()
{
 NbEch=10;
 clearviewport();
 gotoxy(1,1);
 printf(" 1000All.c  %s",Version);
 printf("\nMode video EGA,VGA");
 printf("\nMontage : oscillateur NE555 avec 1000 ohms  0C et C=2.2F ");
 printf("\nconnect sur entrz ACK port LPT%c.",c);
 printf("\nCalibration semi-auto via relayage sur D0,D1,D2,...D7 LPTx");
 Indice=1;
 if (DEMO==FALSE)
 {
  printf("\n\nD0=2 Etalon de 1000 ohms = 0C");
  outportb(Base,1);
  i=0;Zero=0.0;
  do
  {
   Zero=Zero+ACKCount();
   i++;
   printf(".");
   }
  while (i<NbEch);
  printf("\nZero   =%6.2f",Zero);
  printf("\n\nD1=3  Etalon de 1500 ohms =%4.2f",ValEtal);
  outportb(Base,2);
  i=0;
  Echelle=0.0;
  do
  {
   Echelle=Echelle+ACKCount();
   i++;
   printf(".");
  }
  while(i<NbEch);
  printf("\n\nEchelle=%8.0f",Echelle);
  Sensib=ValEtal*NbEch/(Echelle-Zero);
  Echelle=Echelle/NbEch;
  Zero=Zero/NbEch;
  }
 else
 {
  printf("\n\nD0=1 Etalon de 1000 ohms = 0C");
  Zero=2238000;
  printf("\nZero   =%8.0f",Zero);
  printf("\n\nD1=1  Etalon de 1500 ohms =129.87C");
  Echelle=4000000;
  printf("\nEchelle=%8.0f",Echelle);
  Sensib=ValEtal/(Echelle-Zero);
 }
 printf("\n\nSensibilite =%4.5f C par count soit %6.0f points pour %4.1fC",Sensib,Echelle-Zero,ValEtal);
 RatioE=Zero/Echelle;
 printf("\nRatio ETALON <0.666  +- 0.05> =%4.3f",RatioE);
 printf("\nFin de calibration.. ");
 i=(int) (RatioE*100);
 if ((i<71.66)&&(i>61.6))
  {
   setcolor(10);
   printf("......OK  ");
   DEMO=FALSE;
   }
   else
   {
    setcolor(132);
    printf ("...Attention ... Ratio = %3.3f = Bad !",RatioE);
    Couine();
    printf("Donc mode DEMO....");
    DEMO=TRUE;CR;
    }
 printf("\n\n");
 outportb(Base,4);
}

void Pause(char c1)
{
 char c;
 printf("appuyer sur %c",c1);
 do
 {
  if (kbhit()) c=getch();
  if (c>96) c=c-32;
 }
 while (c!=c1);
}

void Delais(int jjj)   /* delai exprim en Milllisecondes */
{
 int iii;
 while (jjj>0)
 {
  for (iii=0;iii<800;iii++);
  jjj--;
 }
}

void Couine()
{
int i;
for (i=100;i<1000;i=i+10)
{
sound(i);
Delais(50);
nosound();
}
nosound();
}

void Boof()
{
int i;
 for (i=500;i>100;i=i-50)
 {
 sound(i);Delais(5);
 }
 nosound();
}

void Burp()
{
 sound(300);
 Delais(100);
 nosound();
}

void Rideau()
{
 int i;
 outportb(Base,0);
 setcolor(0);
 for (i=0;i<=320;i++)
  {
   sound(480-i);
   line(i,0,i,480);
   line(640-i,0,640-i,480);
  }
  Delais(5);
  nosound();
  sleep(1);
  setcolor(0);
  closegraph();
#include "D:\TC\TEMPER\User_tp.txt"
}

void main ()
{
ValEtal=129.87;
BDeg=0;
EDeg=40;
PasDeg=2;
DEMO=TRUE;
RbT= MK_FP (0x0040,0x006c);
Pulse=*(RbT)+*(RbT+2)*65535;
OldPulse=Pulse;
textcolor(15);
clrscr();
textcolor(GREEN); CR
cprintf("Pt1000.c %s",Version);
textcolor(15);CR
cprintf("Rappel:");
printf("\nUne sonde Pt1000 est un lment thermo sensible  base de PLATINE,");
printf("\ncaractris par un coefficient de temprature POSITIF et de valeur");
printf("\nbien dfinie et linaire sur une faible gamme)");
printf("\nCet lment ne necessite donc pas d'talonnage ....");
textcolor(YELLOW);CR
cprintf("Un interface HARDWARE connect sur port parallele LPTx sert  l'acquisition.");
textcolor(8);CR
printf("\nConnection de l'interface sur la prise V25 PORT IMPRIMANTE :");
printf("\n\n  1 STROBE  -> STROBE  non utilis  ");
printf("\n    2 D0      -> cde relais talon 0C    commutation sur 1000 ohms");
printf("\n    3 D1      -> cde relais talon %4.2f C  commutation sur 1500 ohms",ValEtal);
printf("\n    4 D2      -> cde relais commutation   sur SONDE  N1   Pt1000  ");
printf("\n    5 D3      -> cde relais commutation   sur SONDE  N2   Pt1000  ");
printf("\n    ....         ......            ....      ..........   ...   ");
printf("\n    9 D7      -> cde relais commutation   sur SONDE  N6   Pt1000  ");
printf("\n   10 ACK     <- entre de mesure");
printf("\n   25 GROUND ");
printf ("\n\nQuel port imprimante LPT <1> <2> : ");
fflush(stdin);
scanf("%d",&c);
switch (c)
 {
 case 2:
  Base=0x278;
  c=50;
  break;
 case 1:
  c=49;
  Base=0x378;
 default:
  Couine();
  c=49;
  Base=0x378;
 }
 outportb(Base,0);
 /*
 #ifdef NOT_REGISTERED
 printf("\nFaisant suite : schema de l'interface......");
 sleep(1);
 system ("EGAHi.com");
 system ("loadscrn pt1000.EG1");
 gotoxy(65,10);
 Pause('S');
 #endif
 system("texte.com");
*/
 textcolor(15);
 clrscr();
 gotoxy(1,1);
 textcolor(YELLOW);
 printf("Port Lpt choisi  : base =");cprintf("%04X ",Base);
 strcpy(Nom,"Temperat.prn");
 f1=fopen(Nom,"w+b");
 gotoxy(1,2);
 if (f1!=NULL)
  {
  textcolor(GREEN);
  cprintf("Temperat.prn ouvert avec succes...");
  }
   else
   {
   textcolor(RED);
   cprintf("Probleme d'ouverture fichier : Temperat.prn ...");
 }
 do
 {
  gotoxy(1,3);
  printf("Periode de stockage sur fichier <2  32767 secondes> : ");
  scanf("%d",&Ps);
 }
 while (Ps<2 || Ps>32767);
 NbEch=100;
 outportb(Base,4);
 Ticks();
 a=Secondes;
 textcolor(YELLOW);
 gotoxy(1,4);
 cprintf("Test prsence Interface et sonde Pt1000 par comptage des changements ");CR
 cprintf("d'tat signal sur entre ACK port LPT, pendant 2 secondes ou <Q>uitter ");CR
 b=0;d=0;
 c2=0;
 while (c2!='Q'&& Secondes<a+2)
 {
 k=1;
 k=ACK;
 gotoxy(1,6);
 printf("Port %x= %4d  compteur=%8ld   Secondes=%3d\n",Base+1,k,b,Secondes);
 if (k==64 && d==0) { b++;d=1;}
 if (k==0  && d==1) { b++;d=0;}
 if (kbhit()) c2=getch();
 Ticks();
 }
 gotoxy(1,7);
 if (b<5)
 {
  textcolor(RED);
  cprintf("Fin anormale...PROBLEME :");
  printf("\nPas de variation de signal detect sur ACK,port LPT%c .....\n",c);
  printf("\nInterface non connect,ou non aliment,ou ABSENCE SONDE Pt1000.. ");
  Couine();
  printf("\nDonc mode DEMOnstration !!..");
  sleep(1);
  DEMO=TRUE;
  }
  else
  {
   printf("..OK..signal prsent sur ACK LPT%c ...",c);
   DEMO=FALSE;
 }
 sleep(1);
 gotoxy(1,12);
 printf("Etalonnage ?? <O> <N>         ");
 do { if (kbhit()) c2=getch(); if (c2>96) c2=c2-32;} while ((c2!='O')&&(c2!='N'));
 InitGraf();
 if (c2=='O')
 {
  Calibration();
  Pause('S');
 }
 sleep(2);
 Taille=imagesize(599,MaxY/5-HautCar,600,MaxY);
 Tableau2=(char *)farmalloc(Taille);
 printf("\n\nAllocation de %8ld octets russie  partir de l'adresse %Fp ",Taille,Tableau2);
 Taille=imagesize(20,MaxY/8,360,MaxY);
 Tableau1=(char *)farmalloc(Taille);
 if (Tableau1==NULL)
 {
  printf("\nPb memoire ....");
  Couine();
  sleep(2);
  exit(1);
 }
 printf("\nAllocation de %8ld octets russie  partir de l'adresse %Fp ",Taille,Tableau1);

 /* --- init variables --- */
 HautCar=textheight("H")*2;
 BDeg=0;
 EDeg=30; /* was 40 */
 PasDeg=2;
 PasZDeg=0.1;
 MaE=(MaxY-HautCar-MaxY/5)/(EDeg-BDeg);
 ZMaE=(MaxY-HautCar-MaxY/5)/2.0;
 ZOOM=FALSE;
 DrpZOOM=FALSE;
 Tarage();
 if (DEMO==FALSE) k=ACKCount(); else k=3000000+random(5000);
 Temp0=((float)k);
 RatioM=(Temp0-Zero)/(Echelle-Zero);
 Temp1=RatioM*ValEtal;
 Indice=1;
 Grille();

 c2=0;

 /* ---------------- Corps Principal ------------*/

 Moyenne=0.0;
 while (c2!=27)
 {
  if (DEMO==FALSE)
   k=ACKCount();
    else
    k=2500000+random(2500);
  Temp0=((float)k);
  RatioM=(Temp0-Zero)/(Echelle-Zero);
  Temp0=RatioM*ValEtal;
  Temp=0.95*Temp1+0.05*Temp0;
  gotoxy(50,2);
  printf("Count=%6ld Indic=%6d ",k,Indice);
  gotoxy(50,3);
  printf("x  =%5d ",x);
  Ticks();
  if (x>200) Moyenne=Temp;
  Couleur=10;
  if (CarteGraphique > 1) sprintf(Tampon,"%5.3f",Temp); else  sprintf(Tampon,"%5.3f",Temp0);
  Titre(200,10+CarteGraphique*2,3,Tampon);
  /* affiche Trend value */
  if ((x>200) && (Moyenne<EDeg-1.0) && (Moyenne>BDeg+1.0) && (DrpZOOM==FALSE))
    {
    DrpZOOM=TRUE;
    gotoxy(74,4);
    setcolor(2);
    sprintf(Tampon,"%s","Z=ZOOM"),
    settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
    outtextxy(560,36,Tampon);
  }
  if (ZOOM==FALSE)
   {
    if(Temp>EDeg) Temp=EDeg;
    if(Temp<BDeg) Temp=BDeg;
    moveto(x,MaxY-HautCar-(Temp1-BDeg)*MaE);
    lineto(x,MaxY-HautCar-(Temp-BDeg)*MaE);
   }
   else
   {
   if(Temp>EzDeg) Temp=EzDeg;
   if(Temp<BzDeg) Temp=BzDeg;
   moveto(x,MaxY-HautCar-(Temp1-BzDeg)*ZMaE);
   lineto(x,MaxY-HautCar-(Temp-BzDeg)*ZMaE);
  }
  Temp1=Temp;

  /* affiche Now value */
  if ((CarteGraphique>1)&&(ZOOM==FALSE))    /* carte EGA ou VGA only */
  {
  Temp2=Temp0;
  Couleur=12;
  sprintf(Tampon,"%-6.2f",Temp2);
  Titre(200,35+CarteGraphique*2,3,Tampon);
  if(Temp2>EDeg) Temp2=EDeg;
  if(Temp2<BDeg) Temp2=BDeg;
  setcolor(12);
  moveto(x,MaxY-HautCar-(OldTemp2-BDeg)*MaE);
  lineto(x,MaxY-HautCar-(Temp2-BDeg)*MaE);
  OldTemp2=Temp2;
 setcolor(10);
 }
 if(Secondes != OldSec) { Tec++;OldSec=Secondes;}
 if(Tec>Ps)
  {
  Tec=0;
  Tampon[6]=13;
  Tampon[7]='\0';
  fwrite(Tampon,sizeof(char),strlen(Tampon),f1);
  Indice++;
  }
  if (x>598)
  {
   if(ZOOM==FALSE)
   {
    getimage(21,MaxY/5+2,311,MaxY-HautCar,Tableau1);
    putimage(20,MaxY/5+2,Tableau1,COPY_PUT);
    }
    else
    {
    getimage(35,MaxY/5+2,311,MaxY-HautCar,Tableau1);
    putimage(34,MaxY/5+2,Tableau1,COPY_PUT);
   }
   getimage(311,MaxY/5+2,600,MaxY-HautCar,Tableau1);
   putimage(310,MaxY/5+2,Tableau1,COPY_PUT);
   putimage(599,MaxY/5+2,Tableau2,COPY_PUT);
   x=x--;
  }
  if (kbhit()) {c2=getch(); if (c2>96) c2=c2-32;}
  if (c2=='D') { if (DEMO==FALSE) outportb(Base,1); else Boof();}
  if (c2=='F') { if (DEMO==FALSE) outportb(Base,2); else Boof();}
  if (c2=='X') { if (DEMO==FALSE) outportb(Base,4); else Boof();}
  if (c2==27)  break;
  if ((c2=='Z')&&(DrpZOOM==TRUE))
     {
     x=35;
     Grille_ZOOM();
     ZOOM=TRUE;
     textcolor(2);
     gotoxy(50,5);cprintf("N=NORMAL");
     }
  if ((c2=='N')&&(ZOOM==TRUE))
     {
     x=20;
     DrpZOOM=FALSE;
     ZOOM=FALSE;
     Grille();
     textcolor(0);
     gotoxy(50,5);cprintf("        ");
     textcolor(2);
     gotoxy(77,4);cprintf("        ");
     }
   if (c2=='T')
   {
    if (DEMO==FALSE) Tarage();else Burp();
   }
  if (Secondes % 60==0) Tarage();
  x++;
  c2=0;
 }
fclose(f1);
farfree(Tableau2);
farfree(Tableau1);
Rideau();
}
#endif
#ifndef __COMPACT__
#error mode COMPACT siouplait
#endif


