/*
fichier projet: Pt100ALL.prj
-------------------
GRAPHICS.lib
D:\tc\obj\TRIPF.obj
D:\tc\obj\SANSF.obj
D:\tc\obj\EGAVGAF.obj
D:\tc\obj\CGAF.obj
100ALL.c
_____________________

(c)PF

Ŀ
 Nom    : 100all.c         DOS 5.0     Video : MAGIC VGA,EGA,CGA     
 Date   : 23 Novembre 92    Materiel:   Kenitech 386SX VGA  	       
 Auteur : P.FREYER          Langage :   Turbo C v2.00 Borland         
 But    : Mesure de temperature par sonde Pt100 DIN 43760 avec        
          calibration sur 0C et 75C ,mesure ratiometrique au lieu   
          de mesure absolue.Graphique mesure brute et mesure filtre. 
          ZOOM possible sur +/- 0.5C par rapport  moyenne ......... 


V0  	10/88 sur VIDEO GENIE Z80 en pascal et assembleur usage d'un timer 6840
V0.1    12/90 sur XT WENDY 8088 en CGA sur entree PADDLE.
V0.2  	01/91 sur KENITEC 80386SX
V1.0    03/92   avec autocalibration et meilleure rsolution
V1.1    04/92   mode CGA,EGA,VGA + fonction ZOOM +/- 0,5C
V1.10   06/92   integration des drivers CGA,EGAVGA et FONTS
V1.11   11/92   reorganisation cde relais pour possibilit extensions voies
	        soft prevu pour 6 sondes (MAXI)
*/

#ifdef __COMPACT__
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <graphics.h>
#include <alloc.h>
#include <conio.h>

#include "D:\tc\temper\enregist.tpr"
char Version[]={"100all.c V1.11 01/93"};
char Interface[]={"t00all.pcx avec 3 relais,2 R talons,SN7406,SN7413 / Lptx"};
char CopyRight[]={"P.Freyer 1996"};

typedef enum {FALSE,TRUE} bool;
typedef unsigned char byte;
typedef unsigned int word;
typedef enum { ESCAPE=0x0011B,ENTER=0x1C0D,ESPACE=0x3920,CTRL_ENTER=0x1C0A };

union REGS Re,Rs;
struct REGPACK Rg;

#define CR printf("\n");
#define  ACK (inportb(Base+1)& Bit6)
#define Bit6 0x40

int b,i,j,k,l,m;
char a,c,d,c1,c2;

/* variables specifiques mesure de temperature et grafe */

float Zero,Echelle;	/* valeur en counts des etalons 0 et 75 */
float Sensib,MaE;       /* coefficient de mise a l'echelle grafique */
float RatioE;		/* rapport de signal entre 0 et 75 etalons .*/
float RatioM; 	  	/* utilisation du rapport de signal 0,00  1,00 au lieu de val absolue*/
float Temp,Temp0;	/* variables pour elaborer le filtrage exponentiel */
float Temp2,OldTemp2;   /* variables graf NOW MESURE en ega ou vga only */
float Temp1;
float Moyenne;		/* moyenne temperature */
float BDeg,EDeg,Deg;    /*Debut,Fin d'echelle,Valeur en cours*/
float PasDeg;           /* Graduations pour graphe ZOOM */
float ZMaE;		/* coef de Mise  l'echelle C et pixel en mode ZOOM*/

int Base;		/* adresse port paralle : LPt ou Proto */
int NbEch;		/* Population echantillonage mesure */
int Ps;			/* periode de stockage sur fichier */
int Tec; 		/* mesure du temps ecoul en secondes */

byte Secondes; 		/* variables pour detecter le changement de seconde */
byte OldSec;            /* pour etre compatible XT ne utiliser la RAM CMOS horloge*/
word *RbT; 		/* pointeur sur zone Ram comptage pulses 1/18 em de secondes */
long Pulse,OldPulse;

int DrpZOOM,ZOOM;       /* Zoom only si valeur de rference */
int DEMO;		/* si pas d'interface connect */

FILE *f1;
char Tampon[16];
char Nom[13];

long Taille;
int CarteGraphique,ModeGraphique,ErrorCode;
int MaxX,MaxY;
int Indice,x,Drap;
int Couleur;

char far  *Tableau1; /* stockage temporaire pour glissement courbe  grafe */
char far  *Tableau2;

void Ticks();
void InitGraf();
void Titre(int xx,int yy,int zz,char *msx);
void Grille();
word Ackcount();
void Tarage();
void Calibration();
void Pause(char c1);
void Delai(int jjj);
void Couine();
void Boof();
void Burp();
void Rideau();
void ToRegistered();

void Ticks()
{
 disable();
 Pulse=*(RbT)+*(RbT+2)*65535;
 if (Pulse>OldPulse+18)
 {
 Secondes++;
 OldPulse=Pulse;
 }
 enable();
}

void InitGraf()
{
 CarteGraphique=DETECT;
 if(registerfarbgifont(triplex_font_far) < 0)
  {
   Couine();
   printf("\nPb font TRIP non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgifont(sansserif_font_far)<0)
   {
   Couine();
   printf("\nPb font SANS non integree ..");
   sleep(2);
   exit(1);
   }
 if (registerfarbgidriver(EGAVGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver EGAVGA non integree ..");
   sleep(2);
   exit(1);
   }
  if (registerfarbgidriver(CGA_driver_far )<0)
  {
   Couine();
   printf("\nPb Driver CGA non integree ..");
   sleep(2);
   exit(1);
   }
 initgraph (&CarteGraphique,&ModeGraphique,"");
 ErrorCode=graphresult();
 if (ErrorCode!=grOk)
  {
  printf("erreur initialisation Grafique :%s \n",grapherrormsg(ErrorCode));
  sleep(2);
  exit(1);
  }
 MaxX=getmaxx();
 MaxY=getmaxy();
 gotoxy(3,3);
 printf("Initgraf.c");
 gotoxy(3,4);
 printf("Mode detect: ");
 switch (CarteGraphique)
 {
 case 1:printf(" CGA ");break;
 case 2:printf(" MCGA");break;
 case 3:printf(" EGA ");break;
 case 4:printf(" EGA 64 ");break;
 case 5:printf(" EGA mono");break;
 case 6:printf(" IBM 8514");break;
 case 7:printf(" HERCules");break;
 case 9:printf(" VGA ");break;
 case 10:printf(" PC3270 ");break;
 default:printf(" unknow ? ");break;
 }
 printf("  Max X= %5d      Max Y= %5d   ",MaxX,MaxY);
 sleep(1);
 clearviewport();
}

void Titre(int xx,int yy,int zz,char *msx)
{
 setfillstyle(SOLID_FILL,0);
 setcolor(Couleur);
 settextstyle(TRIPLEX_FONT,HORIZ_DIR,zz);
 bar(xx,yy,xx+90,yy+textheight(msx));
 outtextxy(xx,yy,msx);
 setcolor(10);
}

void Grille()
{
 int y;
 float i;
 clearviewport();
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(7);
 for (i=11;i<=29;i++)
  {
   y=MaxY-1-(i-10)*MaE;
   line(20,y,600,y);
   setcolor(3);
   sprintf(Tampon,"%2.0f",i);
   outtextxy(1,y-textheight(Tampon)/2,Tampon);
   setcolor(7);
  }
 for (i=480;i>=0;i=i-60)
  {
   x=600-i;
   setcolor(12);
   line(x,MaxY,x,MaxY-textheight("H")*2);
   setcolor(3);
   sprintf(Tampon,"%2.0f",(480.0-(float)i)/60.0);
   outtextxy(120+i-textwidth(Tampon),MaxY-textheight(Tampon),Tampon);
   setcolor(7);
  }
 strcpy(Tampon,"Duree Mn");
 outtextxy(16,MaxY-10,Tampon);
 setcolor(10);
 Couleur=13;
 strcpy(Tampon,"100.C");
 Titre(25,8+CarteGraphique*2,2+CarteGraphique/3,Tampon);
 gotoxy(1,5);printf("C");
 Couleur=14;
 gotoxy(1,1);
 printf("%s",Version);
 gotoxy(20,1);
 printf("Zero=%6.0f  Echelle=%6.0f Sensibilite =%4.3f C par Cnt",Zero,Echelle,Sensib);
 gotoxy(50,4);
 printf("D=0C F=75C X=100          ");
 gotoxy(50,5);
 printf("          T=Tarage ESC=Sortie");
 settextstyle(SANS_SERIF_FONT,HORIZ_DIR,1);
 getimage(599,MaxY/5+2,600,MaxY-14-CarteGraphique,Tableau2);
 if (CarteGraphique>1)    /* carte EGA ou VGA only */
 {
 Couleur=10;
 strcpy(Tampon,"Filtree");
 Titre(300,10+CarteGraphique*2,2,Tampon);
 Couleur=12;
 strcpy(Tampon,"Brute");
 Titre(300,35+CarteGraphique*2,2,Tampon);
 }
 x=20;
 moveto(x,MaxY-(Temp1-10.0)*MaE);
 OldTemp2=Temp1;
}

void Grille_ZOOM()
{
 float i,y;
 clearviewport();
 gotoxy(1,1);
 printf("%s",Version);
 settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
 setcolor(7);
 PasDeg=0.1;
 BDeg=Moyenne-5.0*PasDeg;
 EDeg=Moyenne+5.0*PasDeg;
 ZMaE=(MaxY-1-MaxY/5)/(10.0*PasDeg);
 for (Deg=BDeg;Deg<=EDeg;Deg=Deg+PasDeg)
  {
   y=MaxY-1-(Deg-BDeg)*ZMaE;
   line(35,y,600,y);
   setcolor(3);
   sprintf(Tampon,"%2.1f",Deg);
   outtextxy(1,y-textheight(Tampon)/2,Tampon);
   setcolor(7);
  }
 for (i=480;i>=0;i=i-60)
  {
   x=600-i;
   setcolor(12);
   line(x,MaxY,x,MaxY-textheight("H")*2);
   setcolor(3);
   sprintf(Tampon,"%2.0f",(480.0-i)/60.0);
   outtextxy(120+i-textwidth(Tampon),MaxY-textheight(Tampon),Tampon);
   setcolor(7);
  }
 strcpy(Tampon,"Duree Mn");
 outtextxy(16,MaxY-10,Tampon);
 setcolor(10);
 Couleur=13;
 strcpy(Tampon,"100.C");
 Titre(25,10+CarteGraphique*2,2+CarteGraphique/3,Tampon);
 gotoxy(1,5);printf("C");
 Couleur=14;
 gotoxy(20,1);
 printf("Zero=%6.0f  Echelle=%6.0f Sensibilite =%4.3f C par Cnt",Zero,Echelle,Sensib);
 gotoxy(50,4);
 printf("D=0C F=75C X=100          ");
 gotoxy(50,5);
 printf("N=NORMAL  T=Tarage ESC=Sortie");
 settextstyle(SANS_SERIF_FONT,HORIZ_DIR,1);
 getimage(599,MaxY/5+2,600,MaxY-14-CarteGraphique,Tableau2);
 if (CarteGraphique>1)    /* carte EGA ou VGA only */
 {
 Couleur=10;
 strcpy(Tampon,"Filtree");
 Titre(300,10+CarteGraphique*2,2,Tampon);
/*
 Couleur=12;
 strcpy(Tampon,"Brute");
 Titre(300,35+CarteGraphique*2,2,Tampon);
*/
 }
 x=35;
 moveto(x,MaxY-(Moyenne-BDeg)*ZMaE);
 Temp1=Temp;

}


word AckCount()
{
disable();
k=0;
while (ACK==0);          /* synchro sur front descendant */
while (ACK==64);         /* synchro sur front montant */
while (ACK==0)  k++;     /* comptage front bas */
while (ACK==64) k++;	 /* comptage front haut */
while (ACK==0)  k++;
while (ACK==64) k++;
/* inib pour Pentium II 400Mhz car debordement
while (ACK==0)  k++;
while (ACK==64) k++;
while (ACK==0)  k++;
while (ACK==64) k++;
while (ACK==0)  k++;
while (ACK==64) k++;
*/
while (ACK==0)  k++;     /* comptage front bas */
while (ACK==64) k++;     /* comptage front haut */
enable();
return(k);
}

void Tarage()
{
int i;
if (DEMO==FALSE)
 {
 NbEch=25;
 outportb(Base,1);
 i=0;
 Zero=0.0;
 do {Zero=Zero+AckCount(); i++; } while (i<NbEch);
 outportb(Base,2);
 i=0;
 Echelle=0.0;
 do { Echelle=Echelle+AckCount();i++;} while(i<NbEch);
 Sensib=75.0*NbEch/(Echelle-Zero);Echelle=Echelle/NbEch;Zero=Zero/NbEch;
 outportb(Base,4);
 }
 else
 {
 randomize();
 Zero=5735;
 Echelle=7014;
 Sensib=75.0/(Echelle-Zero);
 }
 gotoxy(20,1);
 printf("Zero=%6.0f  Echelle=%6.0f Sensibilite =%4.3f C par Cnt",Zero,Echelle,Sensib);
 RatioE=Zero/Echelle;
}

void Calibration()
{
 NbEch=50;
 clearviewport();
 gotoxy(1,1);
 printf(" 100All.c  %s",Version);
 printf("\nVersion CGA,EGA,VGA");
 printf("\nMontage : oscillateur avec 100 ohms  0C et C=4.7F ");
 printf("\nSuivi d'un diviseur par 16 connect sur ACK port LPT%c.",c);
 printf("\nCalibration semi auto via relayage sur D0,D1,D2,...D7 LPTx");
 Indice=1;
 if (DEMO==FALSE)
 {
  printf("\n\nD0=1 Etalon de 100 ohms = 0C");
  outportb(Base,1);
  i=0;Zero=0.0;
  do
  {
   Zero=Zero+AckCount();
   i++;
   if (i %10) printf(".");
   }
  while (i<NbEch);
  printf("\nZero   =%6.2f",Zero);
  printf("\n\nD1=2  Etalon de 129,78 ohms =75C");
  outportb(Base,2);
  i=0;
  Echelle=0.0;
  do
  {
   Echelle=Echelle+AckCount();
   i++;
   if (i%10) printf(".");
  }
  while(i<NbEch);
  printf("\n\nEchelle=%6.2f",Echelle);
  Sensib=75.0*NbEch/(Echelle-Zero);Echelle=Echelle/NbEch;Zero=Zero/NbEch;
  outportb(Base,4);
  }
 else
 {
  printf("\n\nD0=1 Etalon de 100 ohms = 0C");
  Zero=5735.0;
  printf("\nZero   =%6.2f",Zero);
  printf("\n\nD1=2  Etalon de 129,78 ohms =75C");
  Echelle=7014.0;
  printf("\nEchelle=%6.2f",Echelle);
  Sensib=75.0/(Echelle-Zero);
 }
 printf("\n\nSensibilite =%3.3f C par count soit %6.0f points pour 75C",Sensib,Echelle-Zero);
 RatioE=Zero/(Echelle-Zero);
 printf("\nRatio ETALON <4.5> =%4.2f",RatioE);
 printf("\nFin de calibration.. ");
 if ((RatioE<4.6)&&(RatioE>4.4)) printf("..OK  ");else printf ("..Bad ! ");
 printf("\n");
}

void Pause(char c1)
{
 char c;
 printf("appuyer sur %c",c1);
 do
 {
  if (kbhit()) c=getch();
  if (c>96) c=c-32;
 }
 while (c!=c1);
}

void Delai(int jjj)   /* Delai exprim en Milllisecondes */
{
 int iii;
 while (jjj>0)
 {
  for (iii=0;iii<800;iii++);
  jjj--;
 }
}

void Couine()
{
 int i,iii;
 for (i=100;i<1000;i=i+10)
 { sound(i); for (iii=0;iii<2000;iii++); nosound();}
 nosound();
}

void Boof()
{
int i;
 for (i=500;i>100;i=i-50)
 {
 sound(i);Delai(5);
 }
 nosound();
}

void Burp()
{
 sound(300);
 Delai(100);
 nosound();
}

void Rideau()
{
 int i;
 outportb(Base,0);
 setcolor(0);
 for (i=0;i<=320;i++)
  {
   sound(480-i);
   line(i,0,i,480);
   line(640-i,0,640-i,480);
  }
  Delai(5);
  nosound();
  gotoxy(10,10);
  printf("Fin Normale de programme....version %s",Version);
  sleep(2);
  setcolor(0);
  closegraph();
#ifdef NOT_REGISTERED
  clrscr();
  textcolor(GREEN);
  gotoxy(1,5);
  cprintf("Programme issu du PACKAGE TEMPERATURES, distribu en SHAREWARE:");
  CR
  textcolor(MAGENTA);
  cprintf("Version NON ENREGISTREE.....");
  CR
  sleep(3);
#else
#include <USER_tp.txt>

#endif
}

void main ()
{
DEMO=TRUE;
RbT= MK_FP (0x0040,0x006c);
Pulse=*(RbT)+*(RbT+2)*65535;
OldPulse=Pulse;
clrscr();
printf("\n100ALL.c %s",Version);
printf("\nRappel:");
printf("\nUne sonde Pt100 est un lment thermo sensible  base de PLATINE ");
printf("\ncaractris par un coefficient de temprature POSITIF et de valeur");
printf("\nbien dfinie: NORME DIN 43760 (linaire sur une faible gamme)");
printf("\nCet lment ne necessite donc pas d'talonnage mais...");
textcolor(RED);CR
cprintf("Necessite l'interface HARDWARE connect sur port parallele LPTx");
textcolor(8);CR
printf("\nRappel brochage fiche V25 IMPRIMANTE:");
printf("\n\n  1 STROBE  -> STROBE  non utilis  ");
printf("\n    2 D0      -> cde relais talon 0C  commutation sur 100 ohms");
printf("\n    3 D1      -> cde relais talon 75C commutation sur 129.8 ohms");
printf("\n    4 D2      -> cde relais commutation sur SONDE  N1   Pt100  ");
printf("\n    5 D3      -> cde relais commutation sur SONDE  N2   Pt100  ");
printf("\n    ....         ......            ....      ..........   ...   ");
printf("\n    9 D7      -> cde relais commutation sur SONDE  N6   Pt100  ");
printf("\n   10 ACK     <- entre de mesure");
printf("\n   25 GROUND ");
printf ("\n\nQuel port imprimante LPT <1> <2> : ");
fflush(stdin);
scanf("%d",&c);
switch (c)
 {
 case 2:
  Base=0x278;
  c=50;
  break;
  case 1:
  default:
  c=49;
  Base=0x378;
 }
 outportb(Base,0);
 textcolor(YELLOW);
 printf(" soit Port choisi  : base =");cprintf("%04X ",Base);
 printf("\nPeriode de stockage sur fichier <1  32767 secondes> : ");
 scanf("%d",&Ps);
/*
 #ifdef NOT_REGISTERED
 printf("\nFaisant suite : schema de l'interface......");
 sleep(1);
 system ("EGAHi.com");
 system ("loadscrn pt100_2.EG1");
 gotoxy(65,10);
 Pause('S');
 #endif
 system("texte.com");
*/
 InitGraf();
 Taille=imagesize(599,MaxY/8,600,MaxY);
 Tableau2=(char *)farmalloc(Taille);
 gotoxy(1,1);
 printf("Allocation de %8ld octets russie  partir de l'adresse %Fp ",Taille,Tableau2);
 Taille=imagesize(20,MaxY/8,310,MaxY);
 Tableau1=(char *)farmalloc(Taille);
 if (Tableau1==NULL)
 {
  printf("\nPb memoire ....");
  Couine();
  sleep(2);
  exit(1);
 }
 printf("\nallocation de %8ld octets russie  partir de l'adresse %Fp ",Taille,Tableau1);
 NbEch=100;
 strcpy(Nom,"Temperat.prn");
 f1=fopen(Nom,"w+b");
 outportb(Base,4);
 Ticks();
 a=Secondes;
 printf("\nTest presence impulsion pendant 5 secondes ou <Q>uitter ");
 b=0;d=0;
 c2=0;
 while (c2!='Q'&& Secondes<a+5)
 {
 k=1;
 k=ACK;
 gotoxy(1,4);
 printf("Port %x= %4d  compteur=%5d   Secondes=%3d",Base+1,k,b,Secondes);
 if (k==64 && d==0) { b++;d=1;}
 if (k==0  && d==1) { b++;d=0;}
 if (kbhit()) c2=getch();
 Ticks();
 }
 if (b<5)
 {
  printf("\nFin anormale...PROBLEME :");
  printf("\nPas de signal detect sur ACK lpt%c .....\n",c);
  Couine();
  sleep(1);
  printf("\nDonc mode DEMO !!..");
  sleep(1);
  DEMO=TRUE;
  }
  else
  {
   printf("\nOK..signal present sur ACK LPT%c ...",c);
   DEMO=FALSE;
 }
 printf("\n\nEtalonnage ?? <O> <N>         ");
 do { if (kbhit()) c2=getch(); if (c2>96) c2=c2-32;} while ((c2!='O')&&(c2!='N'));
 if (c2=='O')
 {
  Calibration();
 }
 else
 {
 Zero=5735;
 Echelle=7014;
 Sensib=75.0/(Echelle-Zero);
 printf("\nSensibilite =%4.2fcounts par C soit %6.0f points pour 75C",Sensib,Echelle-Zero);
 printf("\nMETTRE SONDE ");
 }
 printf("\n");
 Pause('S');
 if (DEMO==FALSE) k=AckCount(); else k=6000+random(25);
 Temp0=((float)k);
 RatioM=(Temp0-Zero)/(Echelle-Zero);
 Temp1=RatioM*75.0;
 MaE=(MaxY-1-MaxY/5)/20.0;
 ZMaE=(MaxY-1-MaxY/5)/2.0;
 ZOOM=FALSE;
 DrpZOOM=FALSE;
 Indice=1;
 Grille();
 c2=0;

 /* ---------------- Corps Principal ------------*/

 Moyenne=0.0;
 while (c2!=27)
 {
  if (DEMO==FALSE) k=AckCount(); else k=6000+random(25);
  Temp0=((float)k);
  RatioM=(Temp0-Zero)/(Echelle-Zero);
  Temp0=RatioM*75.0;
  Temp=0.95*Temp1+0.05*Temp0;
  gotoxy(50,2);
  printf("Count=%5d Indic=%6d ",k,Indice);
  gotoxy(50,3);
  printf("x    =%5d ",x);
  Ticks();
  if (x>200) Moyenne=Temp;
  Couleur=10;
  if (CarteGraphique > 1) sprintf(Tampon,"%-6.2f",Temp); else  sprintf(Tampon,"%-6.2f",Temp0);
  Titre(200,10+CarteGraphique*2,3,Tampon);
  if ((x>200) && (Moyenne<29.0) && (Moyenne>11.0) && (DrpZOOM==FALSE))
    {
    DrpZOOM=TRUE;
    gotoxy(74,4);
    setcolor(2);
    sprintf(Tampon,"%s","Z=ZOOM"),
    settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
    outtextxy(560,36,Tampon);
  }
  if (ZOOM==FALSE)
   {
    if(Temp>29.0) Temp=29.0;
    if(Temp<11.0) Temp=11.0;
    moveto(x,MaxY-(Temp1-10.0)*MaE);
    lineto(x,MaxY-(Temp-10.0)*MaE);
   }
   else
   {
   if(Temp>EDeg-PasDeg) Temp=EDeg-PasDeg;
   if(Temp<BDeg+PasDeg) Temp=BDeg+PasDeg;
   moveto(x,MaxY-(Temp1-BDeg)*ZMaE);
   lineto(x,MaxY-(Temp-BDeg)*ZMaE);
  }
  Temp1=Temp;
  if ((CarteGraphique>1)&&(ZOOM==FALSE))    /* carte EGA ou VGA only */
  {
  Temp2=Temp0;
  Couleur=12;
  sprintf(Tampon,"%-6.2f",Temp2);
  Titre(200,35+CarteGraphique*2,3,Tampon);
  if(Temp2>29.0) Temp2=29.0;
  if(Temp2<11.0) Temp2=11.0;
  setcolor(12);
  moveto(x,MaxY-(OldTemp2-10.0)*MaE);
  lineto(x,MaxY-(Temp2-10.0)*MaE);
  OldTemp2=Temp2;
 setcolor(10);
 }
 if(Secondes != OldSec) { Tec++;OldSec=Secondes;}
 if(Tec>Ps)
  {
  Tec=0;
  Tampon[6]=13;
  Tampon[7]='\0';
  fwrite(Tampon,sizeof(char),strlen(Tampon),f1);
  Indice++;
  }
  if (x>598)
  {
   if(ZOOM==FALSE)
   {
    getimage(21,MaxY/5+2,311,MaxY-14-CarteGraphique,Tableau1);
    putimage(20,MaxY/5+2,Tableau1,COPY_PUT);
    }
    else
    {
    getimage(35,MaxY/5+2,311,MaxY-14-CarteGraphique,Tableau1);
    putimage(34,MaxY/5+2,Tableau1,COPY_PUT);
   }
   getimage(311,MaxY/5+2,600,MaxY-14-CarteGraphique,Tableau1);
   putimage(310,MaxY/5+2,Tableau1,COPY_PUT);
   putimage(599,MaxY/5+2,Tableau2,COPY_PUT);
   x=x--;
  }
  if (kbhit()) {c2=getch(); if (c2>96) c2=c2-32;}
  if (c2=='D') { if (DEMO==FALSE) outportb(Base,1); else Boof();}
  if (c2=='F') { if (DEMO==FALSE) outportb(Base,2); else Boof();}
  if (c2=='X') { if (DEMO==FALSE) outportb(Base,4); else Boof();}
  if (c2==27)  break;
  if ((c2=='Z')&&(DrpZOOM==TRUE))
     {
     x=35;
     Grille_ZOOM();
     ZOOM=TRUE;
     textcolor(2);
     gotoxy(50,5);cprintf("N=NORMAL");
     }
  if ((c2=='N')&&(ZOOM==TRUE))
     {
     x=20;
     DrpZOOM=FALSE;
     ZOOM=FALSE;
     Grille();
     textcolor(0);
     gotoxy(50,5);cprintf("        ");
     textcolor(2);
     gotoxy(77,4);cprintf("        ");
     }
   if (c2=='T')
   {
    if (DEMO==FALSE) Tarage();else Burp();
   }
  if (Secondes % 60==0) Tarage();
  x++;
  c2=0;
 }
fclose(f1);
farfree(Tableau2);
farfree(Tableau1);
Rideau();
}
#endif
#ifndef __COMPACT__
#error mode COMPACT siouplait
#endif


