    // voir C_AD7896.ASM  (c) PF 04 aout 95
    // Application temperature :  mars 97
	// parametre LPTx
	// En Sortie: 1 mesure de tension par adc 7896
	//            format 12 bits pour 4.01V echelle
	//	 Hardware:     	entree analogique					Dip8 1
	//					masse analogique                    	 6
	//				   	2=D0 = sortie clock                      4
	//	               	3=D1 = sortie selection boitier			 7
	//	               	11=BUSY= entree pour lecture bit         5
	//				   	14=AUTO FEED = sortie pour alim montage  2
	//				   	10=ACK=status ADC busy					 8
	//				   	25=Masse logique                         2
	// 	 		alim stabilise via ZTR 4001                      
	//			mesure de temperature via LM35DZ 10mV/C

#include <iomanip.h>
#include <time.h>
#include <stdlib.h>
#include < conio.h>   
#include <malloc.h>   
#include <windows.h>

#define MaxiBoucles 20

 
HWND hWnd1;
HDC hDc1;
char Texte[100];



char szBuff[255];
long NowValue;
                  
 char TAB=9;
 int i,j,Lptx;
 int counts;   
 char c,c2;
 char Nom[32];
 char *Tampon;
 long TDebut;
 long TFin;
 int  Table[MaxiBoucles+2];  
 float Degre[MaxiBoucles+2];  
 float total=0.0;
 float mini=4096;
 float maxi=0;
 float Volt=0.0;
 float moyenne=0.0;  
 float maxDegre,minDegre,moyDegre;
 double ecart=0.0;
 int  ptr;



void AutoFeedOn (int Lptx)
{
 __asm
 {
    mov dx,Lptx+2
    mov al,0    
	out dx,Al	
 }
}       
void Initialise (int Lptx)
{
 __asm
 {
    mov dx,Lptx     
    mov al,0    
	out dx,Al     
	mov dx,Lptx+1    
    mov al,0    
	out dx,Al
	mov dx,Lptx+2    
    mov al,0
	out dx,Al      

 }
}
                        
int LectAdc7896(int Lptx)
{  
     __asm {  
    cli
	mov dx,Lptx
    mov al,0        
	out dx,Al	
    nop                  
    nop
    mov al,2      
    out dx,Al
    inc dx
tbus: 
    in al,dx
	test al,64
    jnz tbus       

	dec dx
    mov cx,2048
    
    mov bx,0 
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2       
    out dx,al
    mov al,3       
    out dx,al
    mov al,2      
    out dx,al
    mov al,3      
    out dx,al
    mov al,2     
    out dx,al

L0:
    mov al,3      
    out dx,al
    inc dx         
    in al,dx       
    dec dx        
    test al,128
    jnz L1
	or bx,cx
 L1:
    mov al,2       
    out dx,al
    shr cx,1
    jnc L0
    mov al,0
	out dx,al
    mov ax,bx       
    and ax,3FFFh     
    mov counts,ax 
    sti
   	} ;    
  
   return(counts);
 }      
                        
                        
                        
 
// * Pauses for a specified number of microseconds. 
void sleep( clock_t wait )
{
   clock_t warte;
   warte = wait + clock();
   while( warte > clock() ) ;
}
 
  

void main()
{              

 Tampon=(char *)malloc(80);  
 cout << " Version 03/03/97 en Visual C++ 1.5 "<< endl;
 cout << " Lecture Temperature via LM35DZ  sur ADC 12 bits AD7896 "<< endl;
 Lptx=0x278;       
 
 NowValue=GetCurrentTime() ;
 cout << "time : " << NowValue << endl;
 

 Lptx=632;
 cout << " Adresse du port I/O (632=LPT2 888=LPT1) : ";
 cin.get(Tampon,4);  
 i=atoi(Tampon);
 if ((i>0x200) && (i<0x3FF)) Lptx=i;else Lptx=632;
 Initialise(Lptx); 
  sleep(1);  
 c2=0;
 while(c2!=27)
 {   
   //	Touche();
 	cout << " Lptx=" << dec << Lptx << " soit " << hex << Lptx <<"H"<< endl;
 	ptr=1;                
 	while(ptr<=MaxiBoucles)
	 {
	 counts= LectAdc7896 (Lptx);   
	 *(Table+ptr)=counts;  
	 Degre[ptr]=401.0*(float)counts/4096.0;  
	 ptr++;   
	 sleep(1); 
	 }	 
 	total=0;
 	ptr=1;
    while(ptr<=MaxiBoucles)
 	{               
     counts=*(Table+ptr); 
     if (counts<=mini) mini=counts;
	 if (counts>=maxi) maxi=counts;
 	 total=total+(float) counts ;  
     ptr++;
   	}       
 	ptr--;
 	setprecision(3);
 	moyenne=total/MaxiBoucles;
 	cout.width(10); 
 	setiosflags(ios::left);     
  	i--;  
    maxDegre=401.0 * maxi / 4096.0;  
    minDegre=401.0 * mini / 4096.0;       
    moyDegre=401.0 * moyenne / 4096.0;  
   	cout << endl;
   	cout << " Nb mesures : "<< dec << ptr << endl;
   	cout << " Mesure maxi     = "<< dec << maxi << TAB << TAB << maxDegre << endl;
   	cout << " Mesure moyenne  = "<< dec << moyenne << TAB << TAB << moyDegre <<   endl;  
   	cout << " Mesure mini     = "<< dec << mini<< TAB << TAB << minDegre << endl;  
   	cout << endl;
   	ptr=1;                
  	while(ptr<=10)
  	{
	 counts=*(Table+ptr);
	 cout << " mesures : "<< dec << ptr << "= " << counts << TAB << TAB << Degre[ptr]<< endl; 
	 ptr++;
 	} 
 	
 	cout << " Appuyer sur une touche  (Q)uitter  (C)ontinue : ";
 	cin >> Tampon;
 	c2=*(Tampon); ptr=(int) c2;
 	cout << " c2 = "<< dec << ptr << TAB << hex << ptr << dec << endl;
   	if (c2==81)break;
 }	 
 resetiosflags(ios::left); 
 Initialise(Lptx);
 cout << endl << " Fin normale de programme " << endl;
}